/*! \file piethernet.h
 * \brief Ethernet device
*/
/*
    PIP - Platform Independent Primitives
    Ethernet, UDP/TCP Broadcast/Multicast
    Copyright (C) 2014  Ivan Pelipenko peri4ko@gmail.com

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PIETHERNET_H
#define PIETHERNET_H

#include "pitimer.h"
#include "piiodevice.h"
#include "piprocess.h"

class PIP_EXPORT PIEthernet: public PIIODevice
{
	PIIODEVICE(PIEthernet)
	friend class PIPeer;
public:
	
	//! Contructs UDP %PIEthernet with empty read address
	PIEthernet();

	//! \brief Type of %PIEthernet
	enum PIP_EXPORT Type {
		UDP /** UDP - User Datagram Protocol */ ,
		TCP_Client /** TCP client - allow connection to TCP server */ ,
		TCP_Server /** TCP server - receive connections from TCP clients */ ,
		TCP_SingleTCP
	};
	
	//! \brief Parameters of %PIEthernet
	enum PIP_EXPORT Parameters {
		ReuseAddress /** Rebind address if there is already binded */ = 0x1,
		Broadcast /** Broadcast send */ = 0x2
	};

	//! Contructs %PIEthernet with type "type", read address "ip_port" and parameters "params"
	PIEthernet(Type type, const PIString & ip_port = PIString(), const PIFlags<Parameters> params = 0);
	
	virtual ~PIEthernet();

	
	//! Set read address
	void setReadAddress(const PIString & ip, int port) {setPath(ip + ":" + PIString::fromNumber(port));}
	
	//! Set read address in format "i.i.i.i:p"
	void setReadAddress(const PIString & ip_port) {setPath(ip_port);}
	
	//! Set read IP
	void setReadIP(const PIString & ip) {parseAddress(path(), &ip_, &port_); setPath(ip + ":" + PIString::fromNumber(port_));}
	
	//! Set read port
	void setReadPort(int port) {parseAddress(path(), &ip_, &port_); setPath(ip_ + ":" + PIString::fromNumber(port));}
	
	
	//! Set send address
	void setSendAddress(const PIString & ip, int port) {ip_s = ip; port_s = port;}
	
	//! Set send address in format "i.i.i.i:p"
	void setSendAddress(const PIString & ip_port) {parseAddress(ip_port, &ip_s, &port_s);}
	
	//! Set send IP
	void setSendIP(const PIString & ip) {ip_s = ip;}
	
	//! Set send port
	void setSendPort(int port) {port_s = port;}
	
	
	//! Returns read address in format "i.i.i.i:p"
	PIString readAddress() const {return path();}
	
	//! Returns read IP
	PIString readIP() const {parseAddress(path(), &ip_, &port_); return ip_;}
	
	//! Returns read port
	int readPort() const {parseAddress(path(), &ip_, &port_); return port_;}
	
	
	//! Returns send address in format "i.i.i.i:p"
	PIString sendAddress() const {return ip_s + ":" + PIString::fromNumber(port_s);}
	
	//! Returns send IP
	PIString sendIP() const {return ip_s;}
	
	//! Returns send port
	int sendPort() const {return port_s;}

	
	//! Set parameters to "parameters_". You should to reopen %PIEthernet to apply them
	void setParameters(PIFlags<PIEthernet::Parameters> parameters_) {setProperty("parameters", (int)parameters_);}
	
	//! Set parameter "parameter" to state "on". You should to reopen %PIEthernet to apply this
	void setParameter(PIEthernet::Parameters parameter, bool on = true);
	
	//! Returns if parameter "parameter" is set
	bool isParameterSet(PIEthernet::Parameters parameter) const {return ((PIFlags<PIEthernet::Parameters>)(property("parameters").toInt()))[parameter];}
	
	//! Returns parameters
	PIFlags<PIEthernet::Parameters> parameters() const {return (PIFlags<PIEthernet::Parameters>)(property("parameters").toInt());}

	//PIByteArray macAddress() {if (!init_) init(); struct ifreq ifr; memset(&ifr, 0, sizeof(ifr)); memcpy(ifr.ifr_name, "eth0", 5); ioctl(sock, SIOCSIFHWADDR, &ifr); return PIByteArray(&ifr.ifr_hwaddr.sa_data, 6);}
	
	//! Returns %PIEthernet type
	Type type() const {return (Type)(property("type").toInt());}

	
	//! Join to multicast group with address "group". Use only for UDP
	bool joinMulticastGroup(const PIString & group);
	
	//! Leave multicast group with address "group". Use only for UDP
	bool leaveMulticastGroup(const PIString & group);
	
	//! Returns joined multicast groups. Use only for UDP
	const PIStringList & multicastGroups() const {return mcast_groups;}
	
	
	//! Connect to TCP server with address \a readAddress(). Use only for TCP_Client
	bool connect();
	
	//! Connect to TCP server with address "ip":"port". Use only for TCP_Client
	bool connect(const PIString & ip, int port) {setPath(ip + ":" + PIString::fromNumber(port)); return connect();}
	
	//! Connect to TCP server with address "ip_port". Use only for TCP_Client
	bool connect(const PIString & ip_port) {setPath(ip_port); return connect();}
	
	//! Returns if %PIEthernet connected to TCP server. Use only for TCP_Client
	bool isConnected() const {return connected_;}
	
	
	//! Start listen for incoming TCP connections on address \a readAddress(). Use only for TCP_Server
	bool listen(bool threaded = false);
	
	//! Start listen for incoming TCP connections on address "ip":"port". Use only for TCP_Server
	bool listen(const PIString & ip, int port, bool threaded = false) {setReadAddress(ip, port); return listen(threaded);}
	
	//! Start listen for incoming TCP connections on address "ip_port". Use only for TCP_Server
	bool listen(const PIString & ip_port, bool threaded = false) {setReadAddress(ip_port); return listen(threaded);}

	PIEthernet * client(int index) {return clients_[index];}
	int clientsCount() const {return clients_.size_s();}
	PIVector<PIEthernet * > clients() const {return clients_;}

	
	//! Send data "data" with size "size" to address "ip":"port"
	bool send(const PIString & ip, int port, const void * data, int size, bool threaded = false) {ip_s = ip; port_s = port; if (threaded) {writeThreaded(data, size); return true;} return send(data, size);}
	
	//! Send data "data" with size "size" to address "ip_port"
	bool send(const PIString & ip_port, const void * data, int size, bool threaded = false) {parseAddress(ip_port, &ip_s, &port_s); if (threaded) {writeThreaded(data, size); return true;} return send(data, size);}
	
	//! Send data "data" with size "size" to address \a sendAddress() for UDP or \a readAddress() for TCP_Client
	bool send(const void * data, int size, bool threaded = false) {if (threaded) {writeThreaded(data, size); return true;} return (write(data, size) == size);}
	
	//! Send data "data" to address \a sendAddress() for UDP or \a readAddress() for TCP_Client
	bool send(const PIByteArray & data, bool threaded = false) {if (threaded) {writeThreaded(data); return true;} return (write(data) == data.size_s());}

	
	//! Wait for some data and read it to "read_to"
	int read(void * read_to, int max_size);
	
	//! Send data "read_to" with size "max_size" to address \a sendAddress() for UDP or \a readAddress() for TCP_Client
	int write(const void * data, int max_size);
	
	//! Send data "data" to address \a sendAddress() for UDP or \a readAddress() for TCP_Client
	int write(const PIByteArray & data) {return write(data.data(), data.size_s());}
	
	PIString constructFullPath() const;
	
	EVENT1(newConnection, PIEthernet * , client)
	EVENT0(connected)
	EVENT1(disconnected, bool, withError)
	
	
	//! Flags of network interface
	enum PIP_EXPORT InterfaceFlag {
		ifActive /** Is active */ = 0x1,
		ifRunning /** Is running */ = 0x2,
		ifBroadcast /** Support broadcast */ = 0x4,
		ifMulticast /** Support multicast */ = 0x8,
		ifLoopback /** Is loopback */ = 0x10,
		ifPTP /** Is point-to-point */ = 0x20
	};
	
	//! %PIFlags of network interface flags
	typedef PIFlags<InterfaceFlag> InterfaceFlags;
	
	
	//! Network interface descriptor
	struct PIP_EXPORT Interface {
		
		//! System index
		int index;
		
		//! System name
		PIString name;
		
		//! MAC address in format "hh:hh:hh:hh:hh:hh" or empty if there is no MAC address
		PIString mac;
		
		//! IP address in format "i.i.i.i" or empty if there is no IP address
		PIString address;
		
		//! Netmask of IP address in format "i.i.i.i" or empty if there is no netmask
		PIString netmask;
		
		//! Broadcast address in format "i.i.i.i" or empty if there is no broadcast address
		PIString broadcast;
		
		//! Point-to-point address or empty if there is no point-to-point address
		PIString ptp;
		
		//! Flags of interface
		InterfaceFlags flags;
		
		//! Returns if interface is active
		bool isActive() const {return flags[PIEthernet::ifActive];}
		
		//! Returns if interface is running
		bool isRunning() const {return flags[PIEthernet::ifRunning];}
		
		//! Returns if interface support broadcast
		bool isBroadcast() const {return flags[PIEthernet::ifBroadcast];}
		
		//! Returns if interface support multicast
		bool isMulticast() const {return flags[PIEthernet::ifMulticast];}
		
		//! Returns if interface is loopback
		bool isLoopback() const {return flags[PIEthernet::ifLoopback];}
		
		//! Returns if interface is point-to-point
		bool isPTP() const {return flags[PIEthernet::ifPTP];}
	};
	
	
	//! Array of \a Interface with some features
	class PIP_EXPORT InterfaceList: public PIVector<PIEthernet::Interface> {
	public:
		InterfaceList(): PIVector<PIEthernet::Interface>() {}
		
		//! Get interface with system index "index" or 0 if there is no one
		const Interface * getByIndex(int index) const {for (int i = 0; i < size_s(); ++i) if ((*this)[i].index == index) return &((*this)[i]); return 0;}
		
		//! Get interface with system name "name" or 0 if there is no one
		const Interface * getByName(const PIString & name) const {for (int i = 0; i < size_s(); ++i) if ((*this)[i].name == name) return &((*this)[i]); return 0;}
		
		//! Get interface with IP address "address" or 0 if there is no one
		const Interface * getByAddress(const PIString & address) const {for (int i = 0; i < size_s(); ++i) if ((*this)[i].address == address) return &((*this)[i]); return 0;}
		
		//! Get loopback interface or 0 if there is no one
		const Interface * getLoopback() const {for (int i = 0; i < size_s(); ++i) if ((*this)[i].isLoopback()) return &((*this)[i]); return 0;}
	};

	
	//! Returns all system network interfaces
	static InterfaceList interfaces();
	
	static PIString interfaceAddress(const PIString & interface_);
	
	//! Returns all system network IP addresses
	static PIStringList allAddresses();
	
	static void parseAddress(const PIString & ipp, PIString * ip, int * port);
	static PIString macFromBytes(const PIByteArray & mac) {PIString r; for (int i = 0; i < mac.size_s(); ++i) {r += PIString::fromNumber(mac[i], 16).expandLeftTo(2, '0'); if (i < mac.size_s() - 1) r += ":";} return r;}
	static PIByteArray macToBytes(const PIString & mac) {PIByteArray r; PIStringList sl = mac.split(":"); piForeachC (PIString & i, sl) r << uchar(i.toInt(16)); return r;}
	static PIString applyMask(const PIString & ip, const PIString & mask) {struct in_addr ia; ia.s_addr = inet_addr(ip.data()) & inet_addr(mask.data()); return PIString(inet_ntoa(ia));}
	static PIString getBroadcast(const PIString & ip, const PIString & mask) {struct in_addr ia; ia.s_addr = inet_addr(ip.data()) | ~inet_addr(mask.data()); return PIString(inet_ntoa(ia));}

//! \events
//! \{

	//! \fn void newConnection(PIEthernet * client)
	//! \brief Raise on new TCP connection received
	
	//! \fn void connected()
	//! \brief Raise if succesfull TCP connection

	//! \fn void disconnected(bool withError)
	//! \brief Raise if TCP connection was closed

//! \}
//! \ioparams
//! \{
#ifdef DOXYGEN
	//! \brief read ip, default ""
	string ip;
	
	//! \brief read port, default 0
	int port;
	
	//! \brief Broadcast parameter, default false
	bool broadcast;
	
	//! \brief ReuseAddress parameter, default false
	bool reuseAddress;
#endif
//! \}

protected:
	PIEthernet(int sock, PIString ip_port);

	PIString fullPathPrefix() const {return "eth";}
	void configureFromFullPath(const PIString & full_path);
	bool configureDevice(const void * e_main, const void * e_parent = 0);
	
	//! Executes when any read function was successful. Default implementation does nothing
	virtual void received(const void * data, int size) {;}

	bool init();
	bool openDevice();
	bool closeDevice();
	void closeSocket(int & sd);
#ifndef WINDOWS
	static PIString getSockAddr(sockaddr * s) {return s == 0 ? PIString() : PIString(inet_ntoa(((sockaddr_in*)s)->sin_addr));}
#endif


	int sock, sock_s, wrote;
	mutable int port_, port_s, port_c;
	bool connected_, connecting_, listen_threaded, server_bounded;
	sockaddr_in addr_, saddr_;
	mutable PIString ip_, ip_s, ip_c;
	PIThread server_thread_;
	PIVector<PIEthernet * > clients_;
	PIQueue<PIString> mcast_queue;
	PIStringList mcast_groups;
#ifdef WINDOWS
	PIMap<PIString, SOCKET> leafs;
#endif

private:
	static void server_func(void * eth);
	void setType(Type t, bool reopen = true) {setProperty("type", (int)t); if (reopen && isOpened()) {closeDevice(); init(); openDevice();}}

	static std::string ethErrorString() {
#ifdef WINDOWS
		char * msg;
		int err = WSAGetLastError();
		FormatMessageA(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL, err, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPSTR)&msg, 0, NULL);
		return "code " + itos(err) + " - " + string(msg);
#else
		return errorString();
#endif
	}

};

inline bool operator <(const PIEthernet::Interface & v0, const PIEthernet::Interface & v1) {return (v0.name < v1.name);}

#endif // PIETHERNET_H
